dados=read.csv('ohio2.csv',header=TRUE,sep=';')
fuma=dados$fuma[dados$tempo==1]

beta0=c(-2.45,1,1)
beta=c(beta0,1)
sig=0.25

n=length(fuma)
w=rnorm(n,0,sig)

x=cbind(1,fuma,w)
p0=exp(x%*%beta0)/(1+exp(x%*%beta0))
y<-rep(NA,n)
for (i in 1:n) y[i]<-rbinom(1,1,p0[i])
dat<-data.frame(suj=1:n,tempo=rep(1,n),fuma=fuma,resp=y)
tb=table(dat$fuma,dat$resp)
tb[1,]/sum(tb[1,])
tb[2,]/sum(tb[2,])
summary(w)

for (j in 2:12){
x1<-cbind(1,fuma,w,y)
p1<-exp(x1%*%beta)/(1+exp(x1%*%beta))
y<-rep(NA,n)
for (i in 1:n) y[i]<-rbinom(1,1,p1[i])
dat1<-data.frame(suj=1:n,tempo=rep(j,n),fuma=fuma,resp=y)
dat<-rbind(dat,dat1)
}


dados<-dat
ord=order(dados$suj,dados$tempo)
dados<-dados[ord,]

desloca=function(dados,resp,n,t){
varind=matrix(0,nrow(dados),n)
for(j in 1:n){
varind[,j]=c(rep(0,j),resp[1:(nrow(dados)-j)])
varind[seq(j,nrow(dados),t),j]=NA
if(j>1)
varind[which(is.na(varind[,(j-1)])),j]=NA}
list('novodata'=data.frame(dados,varind))}

drop=desloca(dados,dados[,"resp"],1,4)
drop=data.frame(drop)
drop=na.omit(drop)
names(drop)=c("suj","tempo","fuma","resp","prev1")

#attach(drop)
mod1a<-glm(resp~fuma+prev1, family=binomial,data=drop)
#summary(mod1a)


#Ajustando modelos com interceptos aleatrios

library(glmmML)
#mod4a<-glmmML(resp~fuma+prev1, cluster=suj, family=binomial,data=drop)#via Laplace
mod5a<-glmmML(resp~fuma+prev1, cluster=suj, family=binomial,method="ghq",n.points=12,data=drop) #via quadratura gaussiana

summary(mod1a)
#summary(mod4a)
summary(mod5a)

